// Ultimo aggioramento 24/08/2020

#include <Servo.h>

/******************************************************************
                Definizione dei pin e delle variabili
 ******************************************************************/

/*         DA UTILIZZARE SU SCHEDA BQ ZUM CORE REV 2.0            */

/* Schede Supportate */
#define BQ_ZUM_CORE_2_CON_BLUETOOTH_INTERO_4_2   1
#define BQ_ZUM_CORE_2_CON_BLUETOOTH_ESTERNO      2

/******************************************************************
       Selezionare la scheda in uso decommentando il rigo giusto
 ******************************************************************/
int boardSelected = BQ_ZUM_CORE_2_CON_BLUETOOTH_INTERO_4_2;
//int boardSelected = BQ_ZUM_CORE_2_CON_BLUETOOTH_ESTERNO; /* pin 11 (TX1) pin 12 (RX1) */

/******************************************************************
  Verificare i propri PIN prima di caricare lo sketc nella scheda !!
 ******************************************************************/
#define pinruotaSinistra         8   /*  Servo Ruota Sinistra  */
#define pinruotaDestra           9   /*  Servo Ruota Destra    */
#define pinIRSinistro            5   /*  Sensore IR Sinistro   */
#define pinIRCentrale            6   /*  Sensore IR Centrale   */
#define pinIRDestro              7   /*  Sensore IR Destro     */

/* Definitione dei valori dei valori che possono assumere servo a rotazione continua,
   cioè le ruote */
#define ruotaStopValore 90
#define ruotaSinistraAvantiValore 180 // 180 per i servo AR-3606HB,   0 per i servo SM-S4303R
#define ruotaSinistraIndietroValore 0 //   0 per i servo AR-3606HB, 180 per i servo SM-S4303R
#define ruotaDestraAvantiValore 0     //   0 per i servo AR-3606HB, 180 per i servo SM-S4303R
#define ruotaDestraIndietroValore 180 // 180 per i servo AR-3606HB,   0 per i servo SM-S4303R


#define bufferSize           5
#define defaultDelay        10

Servo ruotaSinistra;                    /*  Valores from 0 to 180  */
Servo ruotaDestra;                      /*  Valores from 0 to 180  */

char dataBuffer[bufferSize];
int i = 0;
int numChar = 0;


/******************************************************************
                       Definizione delle funzioni
 ******************************************************************/

void stopRuote() {
  ruotaSinistra.write(ruotaStopValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaStopValore);
  delay(defaultDelay);
}

void vaiAvanti() {
  ruotaSinistra.write(ruotaSinistraAvantiValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaDestraAvantiValore);
  delay(defaultDelay);
}

void vaiIndietro() {
  ruotaSinistra.write(ruotaSinistraIndietroValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaDestraIndietroValore);
  delay(defaultDelay);
}

void vaiAvantiSinistra() {
  ruotaSinistra.write(ruotaStopValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaDestraAvantiValore);
  delay(defaultDelay);
}

void vaiAvantiDestra() {
  ruotaSinistra.write(ruotaSinistraAvantiValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaStopValore);
  delay(defaultDelay);
}

void vaiIndietroSinistra() {
  ruotaSinistra.write(ruotaStopValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaDestraIndietroValore);
  delay(defaultDelay);
}

void vaiIndietroDestra() {
  ruotaSinistra.write(ruotaSinistraIndietroValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaStopValore);
  delay(defaultDelay);
}

void vaiRuotaSinistra() {
  ruotaSinistra.write(ruotaSinistraIndietroValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaDestraAvantiValore);
  delay(defaultDelay);
}

void vaiRuotaDestra() {
  ruotaSinistra.write(ruotaSinistraAvantiValore);
  delay(defaultDelay);
  ruotaDestra.write(ruotaDestraIndietroValore);
  delay(defaultDelay);
}
void checkData(char* data) {

  switch (data[0]) {

    case 'M':
      stopRuote();
      break;

    case 'A':
      vaiAvantiSinistra();
      break;

    case 'U':
      vaiAvanti();
      break;

    case 'F':
      vaiAvantiDestra();
      break;

    case 'L':
      vaiRuotaSinistra();
      break;

    case 'R':
      vaiRuotaDestra();
      break;

    case 'C':
      vaiIndietroSinistra();
      break;

    case 'D':
      vaiIndietro();
      break;

    case 'E':
      vaiIndietroDestra();
      break;
  }

  if (boardSelected == BQ_ZUM_CORE_2_CON_BLUETOOTH_ESTERNO) {
    Serial1.flush();
  }
  else {
    Serial.flush();
  }
}

void setup() {
  if (boardSelected == BQ_ZUM_CORE_2_CON_BLUETOOTH_ESTERNO) {
    Serial1.begin(9600);
    Serial1.flush();
  }
  else {
    Serial.begin(115200);
    Serial.flush();
  }

  ruotaSinistra.attach(pinruotaSinistra);
  ruotaDestra.attach(pinruotaDestra);
  pinMode(pinIRSinistro, INPUT);
  pinMode(pinIRCentrale, INPUT);
  pinMode(pinIRDestro, INPUT);
  
  stopRuote();
}

void loop() {

  if (boardSelected == BQ_ZUM_CORE_2_CON_BLUETOOTH_ESTERNO) {
    if (Serial1.available() > 0) {
      i = 0;
      memset(dataBuffer, 0, sizeof(dataBuffer));
      delay(bufferSize);
      numChar = Serial1.available();
      if (numChar > bufferSize) {
        numChar = bufferSize;
      }
      while (numChar--) {
        dataBuffer[i++] = Serial1.read();
        delay(3);
      }
      checkData(dataBuffer);
    }
  }
  else {
    if (Serial.available() > 0) {
      i = 0;
      memset(dataBuffer, 0, sizeof(dataBuffer));
      delay(bufferSize);
      numChar = Serial.available();
      if (numChar > bufferSize) {
        numChar = bufferSize;
      }
      while (numChar--) {
        dataBuffer[i++] = Serial.read();
        delay(3);
      }
      checkData(dataBuffer);
    }
  }
}
